package cokr.xit.fims.epst.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

import cokr.xit.fims.epst.EpostDlvrRslt;
import cokr.xit.fims.epst.EpostQuery;

/** 전자우편 배달 결과 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2024-01-05	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("epostDlvrRsltMapper")
public interface EpostDlvrRsltMapper extends AbstractMapper {

	/**지정한 조건에 따라 전자우편 배달 결과 목록을 조회하여 반환한다.<br />
	 * @param req 전자우편 배달 결과 조회 조건
	 * @return 전자우편 배달 결과 목록
	 */
	List<DataObject> selectEpostDlvrRsltList(EpostQuery req);

	/**지정한 조건에 따라 전자우편 배달 결과 객체들을 반환한다.
	 * @param req 전자우편 배달 결과 조회 조건
	 * @return 전자우편 배달 결과 객체 목록
	 */
	List<DataObject> selectEpostDlvrRslts(EpostQuery req);

	default DataObject selectEpostDlvrRsltInfo(EpostQuery req) {
		// 기본 정렬
		if (req.getOrderBy() == null) {
			req.setOrderBy("DLVR_RSLT_ID DESC");
		}

		List<DataObject> epostDlvrRslts = selectEpostDlvrRslts(req);

		return !epostDlvrRslts.isEmpty() ? epostDlvrRslts.get(0) : null;
	}

	/**전자우편 배달 결과 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"epostDlvrRslt" - 전자우편 배달 결과</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertEpostDlvrRslt(Map<String, Object> params);

	/**전자우편 배달 결과 정보를 등록한다.
	 * @param epostDlvrRslt 전자우편 배달 결과
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(EpostDlvrRslt epostDlvrRslt) {
		return epostDlvrRslt != null && insertEpostDlvrRslt(params().set("epostDlvrRslt", epostDlvrRslt)) == 1;
	}

	/**전자우편 배달 결과 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"epostDlvrRslt" - 전자우편 배달 결과</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateEpostDlvrRslt(Map<String, Object> params);

	/**전자우편 배달 결과 정보를 수정한다.
	 * @param epostDlvrRslt 전자우편 배달 결과
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(EpostDlvrRslt epostDlvrRslt) {
		return epostDlvrRslt != null && updateEpostDlvrRslt(params().set("epostDlvrRslt", epostDlvrRslt)) == 1;
	}

	/**지정한 전자우편 배달 결과을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"epostDlvrRslt" - 전자우편 배달 결과</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteEpostDlvrRslt(Map<String, ?> params);

	/**전자우편 배달 결과 정보를 삭제한다.
	 * @param epostDlvrRslt 전자우편 배달 결과
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(EpostDlvrRslt epostDlvrRslt) {
		return epostDlvrRslt != null && deleteEpostDlvrRslt(params().set("epostDlvrRslt", epostDlvrRslt)) == 1;
	}

}
